# -*- coding: utf-8 -*-
"""
Created on Wed May 18 09:47:41 2016

@author: phypsh

reads in SQUID-VSM .dat files and re-saves as simpler format .txt files
For SQUID centring files - cuts out unneeded data

"""
import numpy as np
import Stoner
from Stoner.Folders import DataFolder

inpath=r'\\stonerlab\data\Projects\PMA systems\Philippa\Kraken\20160726-ef036-centring\centre\\'
outpath=r'\\stonerlab\data\Projects\PMA systems\Philippa\Kraken\20160726-ef036-centring\centre - formatted\\'

f=DataFolder(inpath, pattern='*.dat')
for i in enumerate(f.files): # don't forget that enumerate gives tuple of index, filepath
    
    d=Stoner.DataFile(np.genfromtxt(i[1],delimiter=',',skip_header=5))
    d.column_headers=['Time','Position','Source','M(emu)','M.R','M.I','mV.R'\
    ,'mV.I','X.R','X.I','minADC','maxADC','mV.Avg','Count','Offset Pos']
    data=Stoner.DataFile()
    data&=d.column('Offset Pos')
    data&=d.column('Source')
    data.column_headers=['Offset Pos','Source']
    filename=i[1].split(r'\\')[-1]
    print filename[0:-4]
    d['filename']=filename
    data['filename']=filename
    data.save((outpath+filename[0:-4])+'_reduced.txt')
    d.save((outpath+filename[0:-4])+'.txt')
    
    