# -*- coding: utf-8 -*-
"""
Created on Tue May 24 15:11:14 2016

@author: phypsh
"""
import matplotlib.pyplot as plt
import numpy as np
import matplotlib.pyplot as plt
from scipy import stats
from scipy.optimize import curve_fit
import Stoner.Analysis as SA

folderpath=r'\\stonerlab\data\Projects\PMA systems\Philippa\Kraken\20160816_ef036\ef036_05\data - py formatted\\'
mvT_filename1='ef03605_MvT_20kOe_20to300K_20160816' #lower H
mvT_filename2='ef03605_MvT_28kOe_20to300K_20160816' #higher H
#import 2 MvT
mvT1=SA.AnalyseFile(folderpath+mvT_filename1+'.txt')
mvT2=SA.AnalyseFile(folderpath+mvT_filename2+'.txt')

#take T and M columns from both files, checking that they are the same T sweep direction
assert (round(mvT1.column('Temperature (K)')[0])==round(mvT2.column('Temperature (K)')[0])), 'Start temperatures not the same!'

#m = m1-H1*(m2-m1)/(H2-H1)
m1=mvT1.column('Moment (emu)')
m2=mvT2.column('Moment (emu)')
merr1=mvT1.column('M. Std. Err. (emu)')
merr2=mvT2.column('M. Std. Err. (emu)')
H1=np.mean(mvT1.column('Magnetic Field (Oe)'))
H2=np.mean(mvT2.column('Magnetic Field (Oe)'))

T=mvT1.column('Temperature (K)')

m = m1-H1*(m2-m1)/(H2-H1)
merr = m*((merr1/m1)**2.+(merr2/m2)**2.)**0.5
# plot m
#plt.errorbar(T,m,yerr=merr,fmt='bo')
m_ms=m/np.mean(m[2:7])
m_ms_err=m_ms*((merr/m)**2.+(stats.sem(m[2:7]))**2.)**0.5
plt.figure()

plt.errorbar(T,m_ms, yerr=m_ms_err,fmt='bo')

data=SA.AnalyseFile()
data&=T
data&=m1
data&=merr1
data&=m2
data&=merr2
data&=m
data&=merr
data&=m_ms
data&=m_ms_err

data.column_headers=['T1 (K)', 'm1 (emu)', 'm1err', 'm2 (emu)', 'm2err', 'm (emu)', 'merr', 'm/ms (emu)', 'm/mserr']
try:
    save_it=raw_input('save file? y/n')
    if save_it=='y':
        data.save(folderpath+mvT_filename2+'_-_'+mvT_filename1+'.txt')
        print 'OK, data saved'
    elif save_it=='n':
        print 'OK, data not saved'
except:
    'something went wrong - nothing saved'        

#fit Bloch function to m  1-C*(4*k*T/(A*d))^(3/2) 
#InitialValues = 1.6e-011(V),0.0294(F),3.55e-010(F),1.38e-023(F)
#Meanings = exchange stiffness,fudge,lattice constant,Boltzmann constant

def fit_Bloch_A(T, A):
    k=1.38e-023
    d=3.55e-010
    C=0.0294
    return 1-C*(4.*k*T/(A*d))**(3./2.)
    
popt, pcov = curve_fit(fit_Bloch_A, T, m_ms, p0=1.6e-011)
print popt, pcov
#spit out value for exchange stiffness constant A
fittedcurve=fit_Bloch_A(T,popt[0])
plt.plot(T, fittedcurve,'r-')
plt.xlabel('T (K)',fontsize='x-large')
plt.ylabel('Ms(T)/Ms(0)',fontsize='x-large')
ann=plt.annotate(mvT_filename1+'\n'+mvT_filename2+'\nA='+"%.3E"%popt[0]+'+/-'\
+"%.3E"%(np.sqrt(pcov[0][0])),(100,1.05))
ann.draggable()